<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarLocationDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarLocationDetail extends AbstractStructArrayBase
{
    /**
     * The RentacarLocationDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarLocationDetail[]
     */
    public $RentacarLocationDetail;
    /**
     * Constructor method for ArrayOfJP_RentacarLocationDetail
     * @uses ArrayOfJP_RentacarLocationDetail::setRentacarLocationDetail()
     * @param \StructType\JP_RentacarLocationDetail[] $rentacarLocationDetail
     */
    public function __construct(array $rentacarLocationDetail = array())
    {
        $this
            ->setRentacarLocationDetail($rentacarLocationDetail);
    }
    /**
     * Get RentacarLocationDetail value
     * @return \StructType\JP_RentacarLocationDetail[]|null
     */
    public function getRentacarLocationDetail()
    {
        return $this->RentacarLocationDetail;
    }
    /**
     * Set RentacarLocationDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocationDetail[] $rentacarLocationDetail
     * @return \ArrayType\ArrayOfJP_RentacarLocationDetail
     */
    public function setRentacarLocationDetail(array $rentacarLocationDetail = array())
    {
        foreach ($rentacarLocationDetail as $arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem instanceof \StructType\JP_RentacarLocationDetail) {
                throw new \InvalidArgumentException(sprintf('The RentacarLocationDetail property can only contain items of \StructType\JP_RentacarLocationDetail, "%s" given', is_object($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) ? get_class($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) : gettype($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem)), __LINE__);
            }
        }
        $this->RentacarLocationDetail = $rentacarLocationDetail;
        return $this;
    }
    /**
     * Add item to RentacarLocationDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocationDetail $item
     * @return \ArrayType\ArrayOfJP_RentacarLocationDetail
     */
    public function addToRentacarLocationDetail(\StructType\JP_RentacarLocationDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarLocationDetail) {
            throw new \InvalidArgumentException(sprintf('The RentacarLocationDetail property can only contain items of \StructType\JP_RentacarLocationDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RentacarLocationDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarLocationDetail
     */
    public function getAttributeName()
    {
        return 'RentacarLocationDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RentacarLocationDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
